Subject: [Sipping] Call transfer implementation on a SIP-IP phone

From: "VIDHI RASTOGI" <[email-masked]>
Date: Mon, 30 Jul 2001 10:59:16 +0530

Hi Jonathan,
We are trying to develop an embedded SIP phone with call control features
like transfer. We want the SIP UA software to work with the traditional POTS
phone that does not have any feature keys.

On a POTS phone transfer is initiated by pressing FLASH and then dialing
digits. Feature invoked by the sequence 'FLASH + DIGITS' can be Blind
transfer (if transferor hangs up before the called party answers),
consultation transfer (if transferor hangs up after the called party
answers) or consultation hold (if the user falshes again). In PSTN scenario
where the intelligence lies in the switch, the switch decides which feature
was invoked based on the user's last action. We are having problems in
mapping the same action "FLASH+DIGITS" to a transfer feature on a SIP IP
phone.

The blind & consultation call flows are entirely different in case of SIP
call flows (draft-ietf-sip-cc-transfer-05.txt). Can you give some clues on
how to map the blind and consultation transfer call flows in SIP to "FLASH +
DIGITS" on a POTS phone. Providing a feature code to initiate transfer from
a POTS like SIP phone may not be appealing to the user.

Any response on this issue would be very helpful.

regards
Vidhi

---

From: Gonzalo Camarillo <[email-masked]>
Date: Mon, 30 Jul 2001 22:21:50 +0300

Hello,

Comments inline:

> answers)

I assume that in consultation transfer the 3 parties are in a small
conference call for a while, right?

> or consultation hold (if the user falshes again). In PSTN scenario

Your UA sends an INVITE to the 3rd party.

1) If you (the user of the POTS-alike phone) hang up before the 200 OK
arrives it means that you are in a blind transfer scenario. You wait
until the 200 OK arrives and for the first moments of the coversation
act as a mixer. You get the audio from the 3rd party and send it to the
first party and vice versa. Then, you send a REFER (using Replaces) to
the first party. The first party will INVITE the 3rd party and you will
be out of the call.

2) If you do not hang up it is because you wanted a consultation
transfer. When the 200 OK from the 3rd party arrives you will act as a
mixer. You will be effectively in a 3 party conferece call where you are
the mixer (end use mixing conference model). After speaking for a while,
you can get out of the call the same way as you did in 1)

3) If you flash it is because you want a consultation hold. In this case
you will send an INVITE with a hold SDP to the first party. When the 3rd
party answers the first party will not hear anything of what you are
saying.

Best regards,

Gonzalo 

>   ------------------------------------------------------------------------
>                            Name: Wipro_Disclaimer.txt
>    Wipro_Disclaimer.txt    Type: Plain Text (text/plain)
>                        Encoding: 7bit

-- 
Gonzalo Camarillo                    Phone :   +1 212 939 71 71
Columbia University                  Mobile:  +358 40 702 35 35
472 Computer Science Building        Fax   :  +358  9 299 30 52
1214 Amsterdam Ave., Mail Code 0401  http://www.hut.fi/~gonzalo
New York, NY 10027                   
USA                              [email-masked]

_______________________________________________
Sipping mailing list  http://www.ietf.org/mailman/listinfo/sipping
This list is for NEW development of the application of SIP
Use [email-masked] for questions on current sip
Use [email-masked] for new developments of core SIP

---

From: Henry Sinnreich <[email-masked]>
Date: Mon, 30 Jul 2001 14:42:04 -0500

Hi to all!

Call transfer in the "pure telephony mode" is OK, but we could also
consider the use of IM between the transferor and the target for example
at the same time. 

This presumes the existence of a PC with SIP UA and 3pcc on the desktop.

What I am really trying to say is that some call scenarios from the
telephony world will change due to IM and presence.

What do you think?

Thanks, Henry

> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]] 
> On Behalf Of Gonzalo Camarillo
> Sent: Monday, July 30, 2001 2:22 PM
> To: [email-masked]
> Cc: [email-masked]; [email-masked]
> Subject: Re: [Sipping] Call transfer implementation on a SIP-IP phone
> 
> 
> Hello,
> 
> Comments inline:
> 
> > On a POTS phone transfer is initiated by pressing FLASH and then 
> > dialing digits. Feature invoked by the sequence 'FLASH + 
> DIGITS' can 
> > be Blind transfer (if transferor hangs up before the called party 
> > answers), consultation transfer (if transferor hangs up after the 
> > called party
> > answers)
> 
> I assume that in consultation transfer the 3 parties are in a 
> small conference call for a while, right?
> 
> > where the intelligence lies in the switch, the switch decides which 
> > feature was invoked based on the user's last action. We are having 
> > problems in mapping the same action "FLASH+DIGITS" to a transfer 
> > feature on a SIP IP phone.
> > 
> > The blind & consultation call flows are entirely different 
> in case of 
> > SIP call flows (draft-ietf-sip-cc-transfer-05.txt). Can you 
> give some 
> > clues on how to map the blind and consultation transfer 
> call flows in 
> > SIP to "FLASH + DIGITS" on a POTS phone. Providing a 
> feature code to 
> > initiate transfer from a POTS like SIP phone may not be 
> appealing to 
> > the user.
> 
> 1) If you (the user of the POTS-alike phone) hang up before 
> the 200 OK arrives it means that you are in a blind transfer 
> scenario. You wait until the 200 OK arrives and for the first 
> moments of the coversation act as a mixer. You get the audio 
> from the 3rd party and send it to the first party and vice 
> versa. Then, you send a REFER (using Replaces) to the first 
> party. The first party will INVITE the 3rd party and you will 
> be out of the call.
> 
> 2) If you do not hang up it is because you wanted a 
> consultation transfer. When the 200 OK from the 3rd party 
> arrives you will act as a mixer. You will be effectively in a 
> 3 party conferece call where you are the mixer (end use 
> mixing conference model). After speaking for a while, you can 
> get out of the call the same way as you did in 1)
> 
> 3) If you flash it is because you want a consultation hold. 
> In this case you will send an INVITE with a hold SDP to the 
> first party. When the 3rd party answers the first party will 
> not hear anything of what you are saying.
> 
> Best regards,
> 
> Gonzalo 
> 
> > 
> Use [email-masked] for questions on current 
> sip Use [email-masked] for new developments of core SIP
>

---

From: Gonzalo Camarillo <[email-masked]>
Date: Mon, 30 Jul 2001 23:17:53 +0300

Hello Henry,

I fully agree with you that some of the typical scenarios in the PSTN
will be very different in the SIP world, where better user interfaces
give us much more flexibility.

However, the question that was posted to the mailing list asked
specifically about a SIP phone with a POTS interface. I was just
answering that question. With a better user interface the user will not
need to flash in order to signal consultation hold, for instace. It will
have a button for that.

About instant messages, it is true that a simple IM might substitute a
whole consultation hold... let's welcome the new SIP-enabled
communication paradigms ;o)

Best regards,

Gonzalo

---

From: "VIDHI RASTOGI" <[email-masked]>
Date: Tue, 31 Jul 2001 17:03:19 +0530

Hi Gonzalo,
Thanks for the reply..

I just modified the blind transfer call-flow a bit.. so that no mixing
capabilities are required at the transferor phone. Please see the following
call-flow:

 	A 		SIP-IP phone (POTS interface) 	C
    (Transferee)		(Transferor)		    (transfer target)
      |                       |
	|     active call       |
	|XXXXXXXXXXXXXXXXXXXXXXX|
	|                       |flash
	|INV (c=0)/200OK/ACK    |
	|<----------------------|
	|				|digits
	|	                  |                         |
	|	                  |        INV              |
                              |------------------------>|
	|                       |onhook                   |
      |                       |        CANCEL/200 OK    |
      |                       |------------------------>|
      |      REFER(Refer-To:C)|                         |
	|<----------------------|

PLease give your comments?

regards
Vidhi

> From: Gonzalo Camarillo [mailto:[email-masked]]
> Sent: Tuesday, July 31, 2001 12:52 AM